// Disable warnings generated by the Windows header files.
#pragma warning(disable : 4514)
#pragma warning(disable : 4201)
#include <windows.h>	// For GetExceptionInformation
#include <stdio.h>		// For printf
#include "exceptionhandler.h"	// For RecordExceptionInfo

// Copyright  1998 Bruce Dawson.

/*
This source file is a test frame work for the exception handler.
*/

// Put whatever code used to be in main() in here.

int HandledMain(int argc, char *argv[])
{
	int CrashCode = 0;	// Default crash type.
	if (argc > 1)
	{
		sscanf(argv[1], "%d", &CrashCode);
	}
	printf("Syntax: ConsoleTest [0-4]\n");
	printf("\n");
	printf("The optional number selects which type of crash to do.\n");
	printf("This is useful for testing the exception handler.\n");
	printf("Look at errorlog.txt for post-mortem details.\n");
	printf("This program will now crash with crash type %d.\n", CrashCode);
	printf("\n");
	CrashTestFunction(CrashCode);
	return 0;
}

int main(int argc, char *argv[])
{
	int Result = -1;
	__try
	{
		Result = HandledMain(argc, argv);
	}
	__except(RecordExceptionInfo(GetExceptionInformation(), "main thread"))
	{
		// Do nothing here - RecordExceptionInfo() has already done
		// everything that is needed. Actually this code won't even
		// get called unless you return EXCEPTION_EXECUTE_HANDLER from
		// the __except clause.
	}
	return Result;
}
